---------------------------------------------------------------------------------
-------------------------- UltimateProgress - core.lua --------------------------
------------------------ created by Aristo - Version 2.0 ------------------------
---------------------------------------------------------------------------------

-- creating globals
UP_Settings = UP_Settings or {}
UP_Functions = UP_Functions or {}
UP_Settings.ProgressActive = false



-- creating locals
local eventHandlers = {}
local addonName = "UltimateProgress2"
local L = LibStub("AceLocale-3.0"):GetLocale("UltimateProgress2", true)






-- EVENT: PLAYER_DEAD
function eventHandlers.PLAYER_DEAD(...)
    if UP_Settings.ProgressActive == true then
        if UP_Settings.DeathActive == true then UP_Functions.DeathSound() end -- DeathSound
        if UP_Settings.ssActive == true then UP_Functions.ssCheck("death") end -- ssCheck
    end
end


-- EVENT: PLAYER_REGEN_DISABLED 
function eventHandlers.PLAYER_REGEN_DISABLED()
    if UP_Settings.ProgressActive == true and UP_Settings.ssActive == true then
        UP_Functions.ssCheck()
    end
end


-- EVENT: CHAT_MSG_ADDON
function eventHandlers.CHAT_MSG_ADDON(prefix, ...)
    if prefix == "UPv2" then 
        UP_Functions.CommIn(...) 
    end
end


-- EVENT: UNIT_AURA
function eventHandlers.UNIT_AURA(unit)
    if UP_Settings.ProgressActive == true then
        if unit == "player" then
            for i = 1, 40 do
                local buffName = UnitBuff("player", i) -- player selfcheck
                if buffName == "Trinken" then
                    UP_Functions.FoodSound()
                    break
                end
            end
        end
    end
end


-- EVENT: UNIT_SPELLCAST_SUCCEEDED
function eventHandlers.UNIT_SPELLCAST_START(unitTarget, castGUID, spellID)
    local bigSS = 20764
    local hughSS = 20765
    if UP_Settings.ProgressActive == true and UP_Settings.ssActive == true then
        if spellID == hughSS then 
            message(L["ChangeSS"])
        elseif spellID == bigSS then
            UP_Functions.ssCheck()
        end
    end
end


-- EVENT: PLAYER_LEVEL_UP
function eventHandlers.PLAYER_LEVEL_UP(level, ...)
    if UP_Settings.ProgressActive == true then
        if level == 60 then message(L["LevelUp"]) end
        UP_Functions.LevelUpSound()
    end
end


-- EVENT: ADDON_LOADED
function eventHandlers.ADDON_LOADED(name)
    if name == addonName then
        if not UP_Settings.CharInited then
            UP_Settings = UP_default
        end
        UP_Settings.ProgressActive = false 
    end
    if name == "UltimateProgress" or IsAddOnLoaded("UltimateProgress") then
         message(L["ErrorBothAddons"])
    end
end


-- COMBAT_LOG_EVENT: SPELL_AURA_APPLIED
-- function eventHandlers.SPELL_AURA_APPLIED(...)
--     local sourceGUID = select(4, ...)
--     local buffName = select(13, ...)
--     local PlayerGUID = UnitGUID("player")

--     if UP_Settings.ProgressActive == true then
        
--         if UP_Settings.FoodActive == true and sourceGUID == PlayerGUID then
--             print(...)
--             --UP_Functions.FoodApplied(true)
--         end
--     end
-- end

-- EVENT: UNIT_SPELLCAST_START
-- function eventHandlers.UNIT_SPELLCAST_START(unitName, spellName, spellRank, ...)
--     print(spellName)
-- end


-- Event Handler
local function onEvent(self, event, ...)
    --  if event == "COMBAT_LOG_EVENT_UNFILTERED" then
    --     return onEvent(self, select(2, CombatLogGetCurrentEventInfo()), CombatLogGetCurrentEventInfo())
    -- elseif eventHandlers[event] then
    --     return eventHandlers[event](...)
    -- end
    return eventHandlers[event](...)
end


local frame = CreateFrame("Frame")
frame:RegisterEvent("CHAT_MSG_ADDON")
frame:RegisterEvent("PLAYER_REGEN_DISABLED")
frame:RegisterEvent("PLAYER_DEAD")
--frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
frame:RegisterEvent("UNIT_AURA")
frame:RegisterEvent("UNIT_SPELLCAST_START")
frame:RegisterEvent("ADDON_LOADED")
frame:RegisterEvent("PLAYER_LEVEL_UP")
frame:SetScript("OnEvent", onEvent)

local e = 0
local a = 0
local o = 0
frame:SetScript("OnUpdate", function(self, elapsed)
    if UP_Settings.ProgressActive == true then
        -- Motivation
        if UP_Settings.MotivationActive == true then
            e = e + elapsed
            if e >= UP_Settings.MotivationTime*60 then
                e = 0
                UP_Functions.Motivation(self, elapsed)
            end
        end

        -- Alcohol
        if UP_Settings.AlcoholActive == true then
            a = a + elapsed
            if a >= UP_Settings.AlcoholTime*60 then
                a = 0
                UP_Functions.Alcohol(self, elapsed)
            end
        end

        -- LowlifeSound
        if UP_Settings.LowlifeActive == true then
            UP_Functions.LowlifeSound()
        end

        -- DungeonFinder (Disabled due to protected function)
        -- if UP_Settings.MakroActive == true then
        --     o = o + elapsed
        --     if o >= UP_Settings.MakroTime*60 then
        --         o = 0
        --         UP_Functions.DungeonFinder(self, elapsed)
        --     end
        -- end  
    end
end)