---------------------------------------------------------------------------------
--------------------- UltimateProgress - MiniMapButton.lua ----------------------
------------------------ created by Aristo - Version 2.0 ------------------------
---------------------------------------------------------------------------------

local type = type
local LibStub = _G.LibStub
local UPButton = LibStub("LibDBIcon-1.0")
local L = LibStub("AceLocale-3.0"):GetLocale("UltimateProgress2", true)
local Title, Version = "|cff00ccffUltimateProgress2|r", "|cff00ccffVersion: 2.0|r"

-- LDB
if not LibStub:GetLibrary("LibDataBroker-1.1", true) then return end

--Make an LDB object
local MiniMapLDB = LibStub:GetLibrary("LibDataBroker-1.1"):NewDataObject("UltimateProgress2", {
	type = "launcher",
	text = "UltimateProgress2",
	icon = "Interface\\Icons\\INV_Drink_01",
	OnTooltipShow = function(tooltip)
		tooltip:AddDoubleLine(Title, Version);
		tooltip:AddLine("Left Click = Start/Stop Progress")
		tooltip:AddLine("Right Click = Send Drink Command")
		tooltip:AddLine("Shift + Left Click = Open Options")
	end,

	OnClick = function(self, button)
		if button == "LeftButton" then
			if IsShiftKeyDown() then
				UP_Functions.OptionsFrameShow()
			else
				UP_Functions.ActivateProgress(UnitName("player"))
			end
		elseif button == "RightButton" then
			if UP_Settings.ProgressActive == true then
				if UP_Settings.DrinkActive == true and UP_Settings.ProgressActive == true then
					UP_Functions.CommOut("Drink", UP_Settings.DrinkActive)
				else
					print(L["DrinkFirst"])
				end
			else
				print(L["ProgressFirst"])
			end
		end
	end,
})

UPButton:Register("UltimateProgress2", MiniMapLDB, UP_Settings.MiniMap);
