---------------------------------------------------------------------------------
----------------------- UltimateProgress - motivation.lua------------------------
------------------------ created by Aristo - Version 2.0 ------------------------
---------------------------------------------------------------------------------

--locals
local SoulStoneBuffed
local L = LibStub("AceLocale-3.0"):GetLocale("UltimateProgress2", true)

--- MOTIVATION ---
do
    -- creating quotes
    local ProgressColor1 = "|cff00ccff"
    local ProgressColor2 = "|r" -- DO NOT CHANGE
    local ProgressMotivation = {} -- DO NOT CHANGE
    ProgressMotivation[1] = ProgressColor1..'"Progress is impossible without change, and those who cannot change their minds cannot change anything." - George Bernard Shaw'..ProgressColor2
    ProgressMotivation[2] = ProgressColor1..'"If there is no struggle, there is no progress." - Frederick Douglass'..ProgressColor2
    ProgressMotivation[3] = ProgressColor1..'"A little progress every day adds up to big results." - Satya'..ProgressColor2
    ProgressMotivation[4] = ProgressColor1..'"Strive for progress, not perfection." - Anonymous'..ProgressColor2
    ProgressMotivation[5] = ProgressColor1..'"Progress is not in enhancing what is, but in advancing toward what will be." - Khalil Gibran'..ProgressColor2
    ProgressMotivation[6] = ProgressColor1..'"Always be a work in progress." - Emily Lillian'..ProgressColor2
    ProgressMotivation[7] = ProgressColor1..'"Work hard for you and your own goals. Progress will come." - Anonymous'..ProgressColor2
    ProgressMotivation[8] = ProgressColor1..'"Progress is not inevitable. It’s up to us to create it." - Anonymous'..ProgressColor2
    ProgressMotivation[9] = ProgressColor1..'"Comfort is the enemy of progress." - P. T. Barnum'..ProgressColor2
    ProgressMotivation[10] = ProgressColor1..'"Never discourage anyone who continually makes progress, no matter how slow." - Plato'..ProgressColor2
    ProgressMotivation[11] = ProgressColor1..'"Some quit due to slow progress. Never grasping the fact that slow progress is progress." - Jeff Olson'..ProgressColor2
    ProgressMotivation[12] = ProgressColor1..'"A lack of focus leads to a lack of progress. Focus. Grind. Grow." - Anonymous'..ProgressColor2
    ProgressMotivation[13] = ProgressColor1..'"Whatever you do you have to keep moving forward." - Martin Luther King'..ProgressColor2
    ProgressMotivation[14] = ProgressColor1..'"Without continual growth and progress, such words as improvement, achievement, and success have no meaning." - Benjamin Franklin'..ProgressColor2
    ProgressMotivation[15] = ProgressColor1..'"Delay is the enemy of progress." - Eliot Spitzer'..ProgressColor2
    ProgressMotivation[16] = ProgressColor1..'"There are only two options: Make progress or make excuses." - Anonymous'..ProgressColor2
    ProgressMotivation[17] = ProgressColor1..'"Allways compare your progress to that of others. You need to be the very best." - Aristo'..ProgressColor2
    ProgressMotivation[18] = ProgressColor1..'"You cannot make progress without making decisions." - Jim Rohn'..ProgressColor2
    ProgressMotivation[19] = ProgressColor1..'"Remember that progress would be impossible if we always did things the way we always have." - Wayne Dyer'..ProgressColor2
    ProgressMotivation[20] = ProgressColor1..'"Honest disagreement is often a good sign of progress." - Gandhi'..ProgressColor2
    -- ProgressMotivation[xy] = ProgressColor1..''..ProgressColor2            -- Sample to create additional Quotes (just insert Quote in '')


    -- print random quote
    local quoteNumber
    local quoteNumber_old = 0
    function UP_Functions.Motivation(self, elapsed)
        repeat
            quoteNumber = random(1, #ProgressMotivation)
        until (quoteNumber_old ~= quoteNumber)
        quoteNumber_old = quoteNumber    
        print(ProgressMotivation[quoteNumber])
    end
end


--- DRINK COMMAND ---
do
    
    local drinkFrame = CreateFrame("Frame", nil, UIParent, "BasicFrameTemplateWithInset")
    drinkFrame:Hide()
    drinkFrame:SetSize(400, 150)
    drinkFrame:SetPoint("CENTER", UIParent, "CENTER")

    drinkFrame.text = drinkFrame:CreateFontString(nil, "OVERLAY")
    drinkFrame.text:SetPoint("CENTER", drinkFrame, "CENTER", 0, 20)
    drinkFrame.text:SetFont("Fonts\\FRIZQT__.TTF", 24)
    drinkFrame.text:SetText(L["DrinkAlert"])

    drinkFrame.closeButton = CreateFrame("Button", nil, drinkFrame, "GameMenuButtonTemplate")
    drinkFrame.closeButton:SetPoint("BOTTOM", drinkFrame, "BOTTOM", 0, 20)
    drinkFrame.closeButton:SetSize(140, 40)
    drinkFrame.closeButton:SetText("Ok")
    drinkFrame.closeButton:SetNormalFontObject("GameFontNormalLarge")
    drinkFrame.closeButton:SetHighlightFontObject("GameFontHighlightLarge")
    drinkFrame.closeButton:SetScript("OnClick", function() drinkFrame:Hide() end)

    function UP_Functions.Drink()
        if UP_Settings.DrinkActive == true then
            drinkFrame:Show()
        elseif UP_Settings.DrinkActive == false then
            UP_Functions.CommOut("Drink", UP_Settings.DrinkActive)
        end        
    end
end


--- SS CHECK ---
do
    local ssFrame = UIParent:CreateTexture(nil, "BACKGROUND", nil, -8)
    ssFrame:SetTexture("Interface/Addons/UltimateProgress/texture/Spell_Shadow_SoulGem.blp")
    ssFrame:SetPoint("CENTER", 0, 300)
    ssFrame:Hide()

    function UP_Functions.ssCheck(status)
        local ssCD = GetItemCooldown(16896)
        if status == "death" and SoulStoneBuffed then
            SendChatMessage("!!! SOULSTONE ON ME !!!", "PARTY")
            message("!!! SOULSTONE !!!")
        elseif not ssCD == 0 then
            ssFrame:Hide()
            return
        else
            local ProgressPartnerName, ProgressPartnerServer = UP_Settings.ProgressPartner:match("(%w+)-*(%w+)")
            local _, playerClass = UnitClass("player")
            if IsInGroup() and not IsInRaid() and playerClass == "WARLOCK" then -- SS check in group
                for groupIndex = 1, MAX_PARTY_MEMBERS do
                    -- local name = UnitName("party"..groupIndex)
                    -- local name2 = name:match("(%w+)")
                    if UnitName("party"..groupIndex) == ProgressPartnerName then
                        for i = 1, 40 do
                            local buffName = UnitBuff("party"..groupIndex, i)
                            if buffName == "Seelenstein-Auferstehung" then
                                ssFrame:Hide()
                                break
                            elseif not ssCD == 0 then
                                ssFrame:Hide()
                                break
                            else
                                ssFrame:Show()       
                            end
                        end
                    end
                end
            end

            for i = 1, 40 do
                local buffName = UnitBuff("player", i) -- player selfcheck
                if buffName == "Seelenstein-Auferstehung" then
                    SoulStoneBuffed = true
                elseif buffName then
                    SoulStoneBuffed = false
                else
                    break                
                end
            end
        end
    end
end


--- Alcohol ---
do
    function UP_Functions.Alcohol(self, elapsed)
        message(L["AlcoholAlert"])
    end
end


--- SOUNDS ---
do
    local soundPathDeath = "Interface/AddOns/UltimateProgress2/sounds/deathSound.wav"
    local soundPathLowlife = "Interface/AddOns/UltimateProgress2/sounds/lowlifeSound.wav"
    local soundPathFood = "Interface/AddOns/UltimateProgress2/sounds/drinkSound.wav"
    local soundPathLevelup = "Interface/AddOns/UltimateProgress2/sounds/levelupSound.wav"
    local _, handleLowlife, handleFood
    local LowlifeCurrActive = false
    local perHealthAlert = 20

    -- Death Sound
    function UP_Functions.DeathSound()
        if LowlifeCurrActive == true then
            StopSound(handleLowlife)
            LowlifeCurrActive = false
        end
        PlaySoundFile(soundPathDeath)
    end

    -- Lowlife Sound
    function UP_Functions.LowlifeSound()
        local currentHealth = UnitHealth("player")
        local maxHealth = UnitHealthMax("player")
        local perHealth = (currentHealth / maxHealth) * 100

        if perHealth <= perHealthAlert and LowlifeCurrActive == false and not UnitIsDeadOrGhost("player") then
            LowlifeCurrActive = true
            _, handleLowlife = PlaySoundFile(soundPathLowlife)
        elseif perHealth > perHealthAlert and LowlifeCurrActive == true then
            LowlifeCurrActive = false
            StopSound(handleLowlife)
        end
    end

    -- Food Sound
    function UP_Functions.FoodSound()
        PlaySoundFile(soundPathFood)
    end

    -- LevelUp Sound
    function UP_Functions.LevelUpSound()
        PlaySoundFile(soundPathLevelup)
    end
end


--- DUNGEONFINDER ---
do
    function UP_Functions.DungeonFinder()
        local msgMakro = UP_Settings.MakroText
        local channelID = GetChannelName("SucheNachGruppe")
        SendChatMessage(msg, "CHANNEL", nil, channelID)
        --SendChatMessage(msgMakro, "SAY", nil)
    end
end