--------------------------------------------------------------------------------
------------------------ UltimateProgress - options.lua ------------------------
----------------------- created by Aristo - Version 2.0 ------------------------
--------------------------------------------------------------------------------
local optionsFrame
local L = LibStub("AceLocale-3.0"):GetLocale("UltimateProgress2", true)
local msgStart = L["ProgressStart"]
local msgStop = L["ProgressStop"]


-- UP_default settings
UP_default = {}
UP_default.ProgressActive = false
UP_default.ProgressPartner = "Addontest-Lakeshire"
UP_default.DeathActive = true
UP_default.FoodActive = true
UP_default.LowlifeActive = true
UP_default.ssActive = true
UP_default.DrinkActive = true
UP_default.PlatzhalterActive = false
UP_default.MotivationActive = true
UP_default.MotivationTime = 2
UP_default.AlcoholActive = true
UP_default.AlcoholTime = 10
UP_default.CharInited = false
UP_default.MakroActive = false
UP_default.MakroTime = 1
UP_default.MakroText = ""

-- FUNCTIONS --
function UP_Functions.ActivateProgress(playerName)
    if UP_Settings.ProgressActive == true then
        optionsFrame.activeButton:SetText("Start Progress")
        optionsFrame.drinkButton:Disable()
        optionsFrame.partnerEditBox:Enable()
        optionsFrame.deathCheckbox:Enable()
        optionsFrame.foodCheckbox:Enable()
        optionsFrame.lowlifeCheckbox:Enable()
        optionsFrame.motivationCheckbox:Enable()
        optionsFrame.motivationSlider:Enable()
        optionsFrame.ssCheckbox:Enable()
        optionsFrame.drinkCheckbox:Enable()
        optionsFrame.unknownCheckbox:Enable()
        optionsFrame.alcoholCheckbox:Enable()
        optionsFrame.alcoholSlider:Enable()
        optionsFrame.safeButton:Enable()
        optionsFrame.resetButton:Enable()
        print(msgStop:format(playerName))

    elseif UP_Settings.ProgressActive == false then
        optionsFrame.activeButton:SetText("Stop Progress")
        if UP_Settings.DrinkActive == false then optionsFrame.drinkButton:Disable() else optionsFrame.drinkButton:Enable() end
        optionsFrame.partnerEditBox:Disable()
        optionsFrame.deathCheckbox:Disable()
        optionsFrame.foodCheckbox:Disable()
        optionsFrame.lowlifeCheckbox:Disable()
        optionsFrame.motivationCheckbox:Disable()
        optionsFrame.motivationSlider:Disable()
        optionsFrame.ssCheckbox:Disable()
        optionsFrame.drinkCheckbox:Disable()
        optionsFrame.unknownCheckbox:Disable()
        optionsFrame.alcoholCheckbox:Disable()
        optionsFrame.alcoholSlider:Disable()
        optionsFrame.safeButton:Disable()
        optionsFrame.resetButton:Disable()
        print(msgStart:format(playerName))
        --UP_Settings.ProgressActive = true
    end
    UP_Settings.ProgressActive = not UP_Settings.ProgressActive
    UP_Functions.CommOut("UP_Settings.ProgressActive", UP_Settings.ProgressActive)
end

local function MakroSave()
    UP_Settings.MakroText = optionsFrame.makroEditBox:GetText()
    UP_Settings.MakroTime = optionsFrame.makroSlider:GetValue()
    if optionsFrame.makroCheckbox:GetChecked() then UP_Settings.MakroActive = true else UP_Settings.MakroActive = false end
    optionsFrame.makroEdtOk:Disable()
    UP_Functions.DungeonFinder()
end

local function SaveSettings()
    UP_Settings.ProgressPartner = optionsFrame.partnerEditBox:GetText()
    UP_Settings.MotivationTime = optionsFrame.motivationSlider:GetValue()
    UP_Settings.AlcoholTime = optionsFrame.alcoholSlider:GetValue()
    if optionsFrame.deathCheckbox:GetChecked() then UP_Settings.DeathActive = true else UP_Settings.DeathActive = false end
    if optionsFrame.foodCheckbox:GetChecked() then UP_Settings.FoodActive = true else UP_Settings.FoodActive = false end
    if optionsFrame.lowlifeCheckbox:GetChecked() then UP_Settings.LowlifeActive = true else UP_Settings.LowlifeActive = false end
    if optionsFrame.motivationCheckbox:GetChecked() then UP_Settings.MotivationActive = true else UP_Settings.MotivationActive = false end
    if optionsFrame.ssCheckbox:GetChecked() then UP_Settings.ssActive = true else UP_Settings.ssActive = false end
    if optionsFrame.drinkCheckbox:GetChecked() then UP_Settings.DrinkActive = true else UP_Settings.DrinkActive = false end
    if optionsFrame.alcoholCheckbox:GetChecked() then UP_Settings.AlcoholActive = true else UP_Settings.AlcoholActive = false end
    if UP_Settings.DrinkActive == false then optionsFrame.drinkButton:Disable() else optionsFrame.drinkButton:Enable() end
    if UP_Settings.ProgressActive == false then optionsFrame.drinkButton:Disable() else optionsFrame.drinkButton:Enable() end
    optionsFrame.activeButton:Enable()
    UP_Settings.CharInited = true
    --MakroSave()

    --optionsFrame.partnerEditBox:SetFocus(false)
end

local function ResetSettings()
    -- UP_Settings.ProgressPartner = UP_default.ProgressPartner
    -- UP_Settings.DeathActive = UP_default.DeathActive
    -- UP_Settings.FoodActive = UP_default.FoodActive
    -- UP_Settings.LowlifeActive = UP_default.LowlifeActive
    -- UP_Settings.MotivationActive = UP_default.MotivationActive
    -- UP_Settings.MotivationTime = UP_default.MotivationTime
    -- UP_Settings.ssActive = UP_default.ssActive
    -- UP_Settings.DrinkActive = UP_default.DrinkActive
    -- UP_Settings.AlcoholActive = UP_default.AlcoholActive
    -- UP_Settings.AlcoholTime = UP_default.AlcoholTime

    optionsFrame.partnerEditBox:SetText(UP_default.ProgressPartner)
    optionsFrame.deathCheckbox:SetChecked(UP_default.DeathActive)
    optionsFrame.foodCheckbox:SetChecked(UP_default.FoodActive)
    optionsFrame.lowlifeCheckbox:SetChecked(UP_default.LowlifeActive)
    optionsFrame.motivationCheckbox:SetChecked(UP_default.MotivationActive)
    optionsFrame.motivationSlider:SetValue(UP_default.MotivationTime)
    optionsFrame.ssCheckbox:SetChecked(UP_default.ssActive)
    optionsFrame.drinkCheckbox:SetChecked(UP_default.DrinkActive)
    optionsFrame.alcoholCheckbox:SetChecked(UP_default.AlcoholActive)
    optionsFrame.alcoholSlider:SetValue(UP_default.AlcoholTime)
    optionsFrame.makroCheckbox:SetChecked(UP_default.MakroActive)
    optionsFrame.makroSlider:SetValue(UP_default.MakroTime)
    optionsFrame.makroEditBox:SetText(UP_default.MakroText)
    if UP_Settings.DrinkActive == false then optionsFrame.drinkButton:Disable() else optionsFrame.drinkButton:Enable() end
    if UP_Settings.ProgressActive == false then optionsFrame.drinkButton:Disable() else optionsFrame.drinkButton:Enable() end
    optionsFrame.activeButton:Disable()
    --optionsFrame.partnerEditBox:SetFocus(false)
end

local function CancelSettings()
    optionsFrame.partnerEditBox:SetText(UP_Settings.ProgressPartner)
    optionsFrame.deathCheckbox:SetChecked(UP_Settings.DeathActive)
    optionsFrame.foodCheckbox:SetChecked(UP_Settings.FoodActive)
    optionsFrame.lowlifeCheckbox:SetChecked(UP_Settings.LowlifeActive)
    optionsFrame.motivationCheckbox:SetChecked(UP_Settings.MotivationActive)
    optionsFrame.motivationSlider:SetValue(UP_Settings.MotivationTime)
    optionsFrame.ssCheckbox:SetChecked(UP_Settings.ssActive)
    optionsFrame.drinkCheckbox:SetChecked(UP_Settings.DrinkActive)
    optionsFrame.alcoholCheckbox:SetChecked(UP_Settings.AlcoholActive)
    optionsFrame.alcoholSlider:SetValue(UP_Settings.AlcoholTime)
    if UP_Settings.DrinkActive == false then optionsFrame.drinkButton:Disable() else optionsFrame.drinkButton:Enable() end
    if UP_Settings.ProgressActive == false then optionsFrame.drinkButton:Disable() else optionsFrame.drinkButton:Enable() end
    optionsFrame.activeButton:Enable()
    optionsFrame:Hide()
end

 function UP_Functions.OptionsFrameShow()
    optionsFrame:Show()
    optionsFrame.partnerEditBox:SetText(UP_Settings.ProgressPartner)
    optionsFrame.deathCheckbox:SetChecked(UP_Settings.DeathActive)
    optionsFrame.foodCheckbox:SetChecked(UP_Settings.FoodActive)
    optionsFrame.lowlifeCheckbox:SetChecked(UP_Settings.LowlifeActive)
    optionsFrame.motivationCheckbox:SetChecked(UP_Settings.MotivationActive)
    optionsFrame.motivationSlider:SetValue(UP_Settings.MotivationTime)
    optionsFrame.ssCheckbox:SetChecked(UP_Settings.ssActive)
    optionsFrame.drinkCheckbox:SetChecked(UP_Settings.DrinkActive)
    optionsFrame.alcoholCheckbox:SetChecked(UP_Settings.AlcoholActive)
    optionsFrame.alcoholSlider:SetValue(UP_Settings.AlcoholTime)
    optionsFrame.makroCheckbox:SetChecked(UP_Settings.MakroActive)
    optionsFrame.makroSlider:SetValue(UP_Settings.MakroTime)
    optionsFrame.makroEditBox:SetText(UP_Settings.MakroText)
    if UP_Settings.DrinkActive == false then optionsFrame.drinkButton:Disable() else optionsFrame.drinkButton:Enable() end
    if UP_Settings.ProgressActive == false then optionsFrame.drinkButton:Disable() else optionsFrame.drinkButton:Enable() end
    
    optionsFrame.activeButton:Enable()
    optionsFrame.makroEdtOk:Disable()
end


-- create optionsFrame
optionsFrame = CreateFrame("Frame", nil, UIParent, "BasicFrameTemplateWithInset")
optionsFrame:Hide()
optionsFrame:SetSize(350, 540)
optionsFrame:SetPoint("CENTER", UIParent, "CENTER")
optionsFrame:EnableMouse(true)
optionsFrame:SetMovable(true)
optionsFrame:SetScript("OnMouseDown", function(self) self:StartMoving() end)
optionsFrame:SetScript("OnMouseUp", function(self) self:StopMovingOrSizing() end)

-- Center
optionsFrame.caption = optionsFrame:CreateFontString(nil, "OVERLAY")
optionsFrame.caption:SetPoint("CENTER", optionsFrame, "TOP", 0, -50)
optionsFrame.caption:SetFont("Fonts\\FRIZQT__.TTF", 18)
optionsFrame.caption:SetText(L["ProgressSettings"])

optionsFrame.activeButton = CreateFrame("Button", nil, optionsFrame, "GameMenuButtonTemplate")
optionsFrame.activeButton:SetPoint("TOP", optionsFrame.caption, "BOTTOM", 0, -20)
optionsFrame.activeButton:SetSize(140, 40)
optionsFrame.activeButton:SetText("Start Progress")
optionsFrame.activeButton:SetNormalFontObject("GameFontNormalLarge")
optionsFrame.activeButton:SetHighlightFontObject("GameFontHighlightLarge")
optionsFrame.activeButton:SetScript("OnClick", function() UP_Functions.ActivateProgress(UnitName("player")) end)

optionsFrame.drinkButton = CreateFrame("Button", nil, optionsFrame, "GameMenuButtonTemplate")
optionsFrame.drinkButton:SetPoint("TOP", optionsFrame.activeButton, "BOTTOM", 0, -10)
optionsFrame.drinkButton:SetSize(140, 30)
optionsFrame.drinkButton:SetText("Drink!")
optionsFrame.drinkButton:SetNormalFontObject("GameFontNormalLarge")
optionsFrame.drinkButton:SetHighlightFontObject("GameFontHighlightLarge")
optionsFrame.drinkButton:Disable()
optionsFrame.drinkButton:SetScript("OnClick", function() UP_Functions.CommOut("Drink", UP_Settings.DrinkActive) end)

optionsFrame.partnerText = optionsFrame:CreateFontString(nil, "OVERLAY")
optionsFrame.partnerText:SetPoint("CENTER", optionsFrame, "TOP", -85, -200)
optionsFrame.partnerText:SetFont("Fonts\\FRIZQT__.TTF", 12)
optionsFrame.partnerText:SetText("Progresspartner:")

optionsFrame.partnerEditBox = CreateFrame("EditBox", nil, optionsFrame, "InputBoxTemplate")
optionsFrame.partnerEditBox:SetSize(150,15)
optionsFrame.partnerEditBox:SetPoint("LEFT", optionsFrame.partnerText, "RIGHT", 10, 0)
optionsFrame.partnerEditBox:SetAutoFocus(false)
optionsFrame.partnerEditBox:SetScript("OnTextChanged", function() optionsFrame.activeButton:Disable() end)

-- Left
optionsFrame.deathCheckbox = CreateFrame("CheckButton", nil, optionsFrame, "UICheckButtonTemplate")
optionsFrame.deathCheckbox:SetPoint("CENTER", optionsFrame, "TOPLEFT", 50, -250)
optionsFrame.deathCheckbox.text:SetText("Death Sound")
optionsFrame.deathCheckbox:SetScript("OnClick", function() optionsFrame.activeButton:Disable() end)

optionsFrame.foodCheckbox = CreateFrame("CheckButton", nil, optionsFrame, "UICheckButtonTemplate")
optionsFrame.foodCheckbox:SetPoint("TOPLEFT", optionsFrame.deathCheckbox, "BOTTOMLEFT", 0, 0)
optionsFrame.foodCheckbox.text:SetText("Food Sound")
optionsFrame.foodCheckbox:SetScript("OnClick", function() optionsFrame.activeButton:Disable() end)

optionsFrame.lowlifeCheckbox = CreateFrame("CheckButton", nil, optionsFrame, "UICheckButtonTemplate")
optionsFrame.lowlifeCheckbox:SetPoint("TOPLEFT", optionsFrame.foodCheckbox, "BOTTOMLEFT", 0, 0)
optionsFrame.lowlifeCheckbox.text:SetText("Lowlife Sound")
optionsFrame.lowlifeCheckbox:SetScript("OnClick", function() optionsFrame.activeButton:Disable() end)

optionsFrame.motivationCheckbox = CreateFrame("CheckButton", nil, optionsFrame, "UICheckButtonTemplate")
optionsFrame.motivationCheckbox:SetPoint("TOPLEFT", optionsFrame.lowlifeCheckbox, "BOTTOMLEFT", 0, -20)
optionsFrame.motivationCheckbox.text:SetText("Motivation")
optionsFrame.motivationCheckbox:SetScript("OnClick", function() optionsFrame.activeButton:Disable() end)

optionsFrame.motivationSlider = CreateFrame("Slider", nil, optionsFrame, "OptionsSliderTemplate")
optionsFrame.motivationSlider:SetWidth(120)
optionsFrame.motivationSlider:SetPoint("TOPLEFT", optionsFrame.motivationCheckbox, "BOTTOMLEFT", 0, 0)
optionsFrame.motivationSlider:SetMinMaxValues(1,5)
optionsFrame.motivationSlider:SetValue(UP_Settings.MotivationTime or 1)
optionsFrame.motivationSlider:SetObeyStepOnDrag(true)
optionsFrame.motivationSlider:SetValueStep(1)
optionsFrame.motivationSlider:SetScript("OnValueChanged", function() 
    optionsFrame.motivationText:SetText(optionsFrame.motivationSlider:GetValue())
    optionsFrame.activeButton:Disable()
 end)

optionsFrame.motivationText = optionsFrame:CreateFontString(nil, "OVERLAY")
optionsFrame.motivationText:SetPoint("TOP", optionsFrame.motivationSlider, "BOTTOM", 0, 2)
optionsFrame.motivationText:SetFont("Fonts\\FRIZQT__.TTF", 10)
optionsFrame.motivationText:SetText(optionsFrame.motivationSlider:GetValue())

optionsFrame.makroCheckbox = CreateFrame("CheckButton", nil, optionsFrame, "UICheckButtonTemplate")
optionsFrame.makroCheckbox:SetPoint("TOPLEFT", optionsFrame.motivationCheckbox, "BOTTOMLEFT", 0, -40)
optionsFrame.makroCheckbox.text:SetText("DungeonSpam")
optionsFrame.makroCheckbox:SetScript("OnClick", function(self) 
    if self:GetChecked() then UP_Settings.MakroActive = true else UP_Settings.MakroActive = false end end)

-- Right
optionsFrame.ssCheckbox = CreateFrame("CheckButton", nil, optionsFrame, "UICheckButtonTemplate")
optionsFrame.ssCheckbox:SetPoint("CENTER", optionsFrame, "TOPRIGHT", -150, -250)
optionsFrame.ssCheckbox.text:SetText("Soul Stone Check")
optionsFrame.ssCheckbox:SetScript("OnClick", function() optionsFrame.activeButton:Disable() end)

optionsFrame.drinkCheckbox = CreateFrame("CheckButton", nil, optionsFrame, "UICheckButtonTemplate")
optionsFrame.drinkCheckbox:SetPoint("TOPLEFT", optionsFrame.ssCheckbox, "BOTTOMLEFT", 0, 0)
optionsFrame.drinkCheckbox.text:SetText("Drink Alert")
optionsFrame.drinkCheckbox:SetScript("OnClick", function() optionsFrame.activeButton:Disable() end)

optionsFrame.unknownCheckbox = CreateFrame("CheckButton", nil, optionsFrame, "UICheckButtonTemplate")
optionsFrame.unknownCheckbox:SetPoint("TOPLEFT", optionsFrame.drinkCheckbox, "BOTTOMLEFT", 0, 0)
optionsFrame.unknownCheckbox.text:SetText("*Platzhalter*")

optionsFrame.alcoholCheckbox = CreateFrame("CheckButton", nil, optionsFrame, "UICheckButtonTemplate")
optionsFrame.alcoholCheckbox:SetPoint("TOPLEFT", optionsFrame.unknownCheckbox, "BOTTOMLEFT", 0, -20)
optionsFrame.alcoholCheckbox.text:SetText("Alkohol Timer")
optionsFrame.alcoholCheckbox:SetScript("OnClick", function() optionsFrame.activeButton:Disable() end)

optionsFrame.alcoholSlider = CreateFrame("Slider", nil, optionsFrame, "OptionsSliderTemplate")
optionsFrame.alcoholSlider:SetWidth(120)
optionsFrame.alcoholSlider:SetPoint("TOPLEFT", optionsFrame.alcoholCheckbox, "BOTTOMLEFT", 0, 0)
optionsFrame.alcoholSlider:SetMinMaxValues(1,15)
optionsFrame.alcoholSlider:SetValue(UP_Settings.AlcoholTime or 1)
optionsFrame.alcoholSlider:SetObeyStepOnDrag(true)
optionsFrame.alcoholSlider:SetValueStep(1)
optionsFrame.alcoholSlider:SetScript("OnValueChanged", function()
     optionsFrame.alcoholText:SetText(optionsFrame.alcoholSlider:GetValue())
     optionsFrame.activeButton:Disable()
    end)

optionsFrame.alcoholText = optionsFrame:CreateFontString(nil, "OVERLAY")
optionsFrame.alcoholText:SetPoint("TOP", optionsFrame.alcoholSlider, "BOTTOM", 0, 2)
optionsFrame.alcoholText:SetFont("Fonts\\FRIZQT__.TTF", 10)
optionsFrame.alcoholText:SetText(optionsFrame.alcoholSlider:GetValue())

optionsFrame.makroSlider = CreateFrame("Slider", nil, optionsFrame, "OptionsSliderTemplate")
optionsFrame.makroSlider:SetWidth(120)
optionsFrame.makroSlider:SetPoint("TOPLEFT", optionsFrame.alcoholCheckbox, "BOTTOMLEFT", 0, -40)
optionsFrame.makroSlider:SetMinMaxValues(.5,5)
optionsFrame.makroSlider:SetValue(UP_Settings.MakroTime or 1)
optionsFrame.makroSlider:SetObeyStepOnDrag(true)
optionsFrame.makroSlider:SetValueStep(.5)
optionsFrame.makroSlider:SetScript("OnValueChanged", function()
     optionsFrame.makroText:SetText(optionsFrame.makroSlider:GetValue())
     optionsFrame.makroEdtOk:Enable()
    end)

optionsFrame.makroText = optionsFrame:CreateFontString(nil, "OVERLAY")
optionsFrame.makroText:SetPoint("TOP", optionsFrame.makroSlider, "BOTTOM", 0, 2)
optionsFrame.makroText:SetFont("Fonts\\FRIZQT__.TTF", 10)
optionsFrame.makroText:SetText(optionsFrame.makroSlider:GetValue())

-- Bottom
optionsFrame.makroEditBox = CreateFrame("EditBox", nil, optionsFrame, "InputBoxTemplate")
optionsFrame.makroEditBox:SetSize(250,15)
optionsFrame.makroEditBox:SetPoint("TOPLEFT", optionsFrame.makroCheckbox, "BOTTOMLEFT", 5, 0)
optionsFrame.makroEditBox:SetAutoFocus(false)
optionsFrame.makroEditBox:SetScript("OnTextChanged", function() optionsFrame.makroEdtOk:Enable() end)

optionsFrame.makroEdtOk = CreateFrame("Button", nil, optionsFrame, "GameMenuButtonTemplate")
optionsFrame.makroEdtOk:SetPoint("Left", optionsFrame.makroEditBox, "RIGHT", 0, 0)
optionsFrame.makroEdtOk:SetSize(25, 25)
optionsFrame.makroEdtOk:SetText("Ok")
optionsFrame.makroEdtOk:Disable()
optionsFrame.makroEdtOk:SetNormalFontObject("GameFontNormalSmall")
optionsFrame.makroEdtOk:SetHighlightFontObject("GameFontHighlightSmall")
optionsFrame.makroEdtOk:SetScript("OnClick", MakroSave)


optionsFrame.safeButton = CreateFrame("Button", nil, optionsFrame, "GameMenuButtonTemplate")
optionsFrame.safeButton:SetPoint("TOP", optionsFrame.motivationSlider, "BOTTOM", -20, -80)
optionsFrame.safeButton:SetSize(90, 40)
optionsFrame.safeButton:SetText("Apply")
optionsFrame.safeButton:SetNormalFontObject("GameFontNormalLarge")
optionsFrame.safeButton:SetHighlightFontObject("GameFontHighlightLarge")
optionsFrame.safeButton:SetScript("OnClick", SaveSettings)

optionsFrame.resetButton = CreateFrame("Button", nil, optionsFrame, "GameMenuButtonTemplate")
optionsFrame.resetButton:SetPoint("LEFT", optionsFrame.safeButton, "RIGHT", 10, 0)
optionsFrame.resetButton:SetSize(90, 40)
optionsFrame.resetButton:SetText("Reset")
optionsFrame.resetButton:SetNormalFontObject("GameFontNormalLarge")
optionsFrame.resetButton:SetHighlightFontObject("GameFontHighlightLarge")
optionsFrame.resetButton:SetScript("OnClick", ResetSettings)

optionsFrame.cancelButton = CreateFrame("Button", nil, optionsFrame, "GameMenuButtonTemplate")
optionsFrame.cancelButton:SetPoint("LEFT", optionsFrame.resetButton, "RIGHT", 10, 0)
optionsFrame.cancelButton:SetSize(90, 40)
optionsFrame.cancelButton:SetText("Cancel")
optionsFrame.cancelButton:SetNormalFontObject("GameFontNormalLarge")
optionsFrame.cancelButton:SetHighlightFontObject("GameFontHighlightLarge")
optionsFrame.cancelButton:SetScript("OnClick", CancelSettings)
